"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class SampleState(ProtocolElement):
    """
    No documentation
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {}

    @classmethod
    def getEmbeddedTypes(cls):
        return {}

    @classmethod
    def getEmbeddedEnums(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_8_1 import metrics as metrics_1_2_3

        return {
            "reason": metrics_1_2_3.StateReason,
            "state": metrics_1_2_3.SampleStates,
        }

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_8_1 import metrics as metrics_1_2_3

        return {
            "org.gel.models.report.avro.StateReason": metrics_1_2_3.StateReason,
            "org.gel.models.report.avro.SampleStates": metrics_1_2_3.SampleStates,
            "org.gel.models.report.avro.SampleState": metrics_1_2_3.SampleState,
        }

    __slots__ = [
        "issueIdentifier",
        "otherReasons",
        "reason",
        "state",
    ]

    def __init__(
        self,
        issueIdentifier=None,
        otherReasons=None,
        reason=None,
        state=None,
        validate=None,
        **kwargs
    ):
        """Initialise the metrics_1_2_3.SampleState model.

        :param issueIdentifier:
        :type issueIdentifier: None | list[str]
        :param otherReasons:
        :type otherReasons: None | list[str]
        :param reason:
        :type reason: None | list[StateReason]
        :param state:
        :type state: None | SampleStates
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "1.2.3"
